clear;   % Table 13

load TFuturesReturn;
load TSPReturn;
load dates;
load Tbasis;
load TSpecNetLongChange;
load THedgeNetLongChange;
load TNonNetLongChange;
load TSpecNetLong;
load THedgeNetLong;
load TNonNetLong;
load TraderNumber;

roll=52;
ss=26;
Spec=zeros(ss,1);

     [hh I]=sort(mean(TraderNumber,1));  % can also sort on DollarOI
     %select=I(14:26);
     select=I(1:13);  % 1:13 for small half
Tout=[];

for istep=0:1  % 0 for lag one period, 1 for lag two period
    
TFama=[];
TR=[];

for i=roll+5:size(TFuturesReturn,1)
    
    for bcount=1:ss
        ret=ols(TFuturesReturn(i-roll-istep:i-1-istep,bcount),[ones(roll,1) TSPReturn(i-roll-istep:i-1-istep)]);
        beta(bcount,1)=ret.beta(2);
        rstd(bcount,1)=std(ret.resid)*sqrt(52);
    end
    
    basis=Tbasis(i-1-istep,select)';
    
    LReturn=TFuturesReturn(i-1-istep,select)';

    
    key=THedgeNetLongChange(i-1-istep,select)'; % can change to spec
    
    cc= find(TSpecNetLong(i-1-istep,select)>=0);
    dd= find(TSpecNetLong(i-1-istep,select)<0);
    
    Spec(cc)=1; Spec(dd)=-1;
    
    tBes=Spec.*rstd;
    Bes=tBes(select);
    
    br=TFuturesReturn(i,select)';
    
    ret2=ols(br ,[ones(size(select,2),1) key LReturn basis Bes ]);
        
   
    TFama=[TFama;ret2.beta'];

    
    TR=[TR;ret2.rsqr'];

    
end

bb=mean(TFama);

for i=1:size(bb,2)
    rr=nwest(TFama(:,i),[ones(size(TFama,1),1)],4);
    t(i)=rr.tstat;
end

out=[bb'*100,t'];

tout=[];
for i=2:size(out,1)
    tout=[tout;[out(i,1);out(i,2)]];
end

   tout=[tout;mean(TR)];
   
   Tout=[Tout,tout];
end

