clear;  % Table 9
load TFuturesReturn;
load TSPReturn;
load dates;
load Tbasis;
load TSpecNetLongChange;
load THedgeNetLongChange;
load TNonNetLongChange;
load TSpecNetLong;
load THedgeNetLong;
load TNonNetLong;
load TOI;


roll=52;
ss=26; 

for i=roll+1:size(TFuturesReturn,1)
    
    for bcount=1:ss
        ret=ols(TFuturesReturn(i-roll+1:i,bcount),[ones(roll,1) TSPReturn(i-roll+1:i)]);
        beta(i,bcount)=ret.beta(2);
        rstd(i,bcount)=std(ret.resid)*sqrt(52);
          smoothHedge(i,bcount)=-mean(THedgeNetLong(i-roll+1:i,bcount))/TOI(i,bcount);
    end

end

  istep=0;

tFuturesReturn=[];
tbasis=[];
tHedgeNetLongChange=[];
tHedgeSmooth=[];
tPressure=[];
dummy=[];
newvar=[];
LReturn=[];
   Spec=zeros(size(TSpecNetLongChange(roll+1:end-1,1)));
   s2=size(TFuturesReturn(roll+2:end,1),1);
   dummy=zeros(s2*ss,ss);
   
for index=1:ss
    tFuturesReturn=[tFuturesReturn;TFuturesReturn(roll+2:end,index)];
    tbasis=[tbasis;Tbasis(roll+1-istep:end-1-istep,index)];
    tHedgeNetLongChange=[tHedgeNetLongChange; THedgeNetLongChange(roll+1-istep:end-1-istep,index)];

     tHedgeSmooth=[tHedgeSmooth;smoothHedge(roll+1-istep:end-1-istep,index)];
    cc= find(TSpecNetLong(roll+1-istep:end-1-istep,index)>=0);
    dd= find(TSpecNetLong(roll+1-istep:end-1-istep,index)<0);
    Spec(cc)=1; Spec(dd)=-1;
    tPressure=[tPressure;Spec.*rstd(roll+1-istep:end-1-istep,index)];
    
    dummy(s2*(index-1)+1:s2*index,index)=1;
        
    newvar=[newvar;sign(THedgeNetLongChange(roll-istep:end-2-istep,index))+sign(THedgeNetLongChange(roll+1-istep:end-1-istep,index))+sign(THedgeNetLongChange(roll-1-istep:end-3-istep,index))+sign(THedgeNetLongChange(roll-2-istep:end-4-istep,index))];
    
   LReturn=[LReturn;TFuturesReturn(roll+1-istep:end-1-istep,index)];
end
    
br=tFuturesReturn;

zz=zeros(size(newvar));
cc=find(abs(newvar)==4);
zz(cc)=1;

reg=[tHedgeNetLongChange zz.*tHedgeNetLongChange tHedgeSmooth zz tbasis tPressure LReturn dummy];

ret=nwest(br,reg,4);

time=dates(roll+1-istep:end-1-istep);
Ttime=repmat(time,ss,1);
commodity=ones(size(TFuturesReturn(roll+2:end,1)))*[1:ss];
Commodity=reshape(commodity,size(TFuturesReturn(roll+2:end,1),1)*ss,1);

ret2 = nwestpanel(br, reg,4, Commodity,Ttime, 0);

out=[ret.beta(1)*100;ret2(1,3);ret.beta(2)*100;ret2(2,3);ret.beta(3)*100;ret2(3,3);ret.rsqr]