clear;   % Table 6

load TFuturesReturn;
load TSPReturn;
load dates;
load Tbasis;
load TSpecNetLongChange;
load THedgeNetLongChange;
load TNonNetLongChange;
load TSpecNetLong;
load THedgeNetLong;
load TNonNetLong;
load TOI;% open interest


roll=52;

TFama=[];

TR=[];


ss=26;
Spec=zeros(ss,1);

for i=roll:size(TFuturesReturn,1)
 for bcount=1:ss
    smoothHedge(i,bcount)=-mean(THedgeNetLong(i-roll+1:i,bcount));
 end
end

% change -1 to -2, you get lag 2 period 
for i=roll+1:size(TFuturesReturn,1)
    
    for bcount=1:ss
        ret=ols(TFuturesReturn(i-roll:i-1,bcount),[ones(roll,1) TSPReturn(i-roll:i-1)]);
        beta(bcount,1)=ret.beta(2);
        rstd(bcount,1)=std(ret.resid)*sqrt(52);
    end
    
    basis=Tbasis(i-1,1:ss)';

   % Hedge=-THedgeNetLong(i-1,1:ss)'./TOI(i-1,1:ss)'; % deroon measure
    
   Hedge=smoothHedge(i-1,1:ss)'./TOI(i-1,1:ss)'; % our measure
    
    key=THedgeNetLongChange(i-1,1:ss)';
    
    cc= find(TSpecNetLong(i-1,1:ss)>=0);
    dd= find(TSpecNetLong(i-1,1:ss)<0);
    
    Spec(cc)=1; Spec(dd)=-1;
    
    ret2=ols(TFuturesReturn(i,:)',[ones(ss,1) Hedge key basis Spec.*rstd TFuturesReturn(i-1,:)']);
    
 % ret2=ols(TFuturesReturn(i,:)',[ones(ss,1) Hedge basis Spec.*rstd TFuturesReturn(i-1,:)']);
    
    TFama=[TFama;ret2.beta'];

    
    TR=[TR;ret2.rsqr'];

    
end

bb=mean(TFama);

for i=1:size(bb,2)
    rr=nwest(TFama(:,i),[ones(size(TFama,1),1)],4);
    t(i)=rr.tstat;
end

out=[bb',t'];
out=[out;mean(TR) nan]