clear; %Table 12
load TFuturesReturn;
load TSPReturn;
load dates;
load Tbasis;
load TSpecNetLongChange;
load THedgeNetLongChange;
load TNonNetLongChange;
load TSpecNetLong;
load THedgeNetLong;
load TNonNetLong;
load TOI;


out=[];
roll=52;
ss=26; 

rollmom=52;

for i=roll:size(TFuturesReturn,1)
    
    for bcount=1:ss
        ret=ols(TFuturesReturn(i-roll+1:i,bcount),[ones(roll,1) TSPReturn(i-roll+1:i)]);
        beta(i,bcount)=ret.beta(2);
        rstd(i,bcount)=std(ret.resid)*sqrt(52);
        mom(i,bcount)=sum(TFuturesReturn(i-rollmom+1:i,bcount));
    end

end

   
   istep=0;  % 0 for lag one period, 1 for lag two period
   
   Spec=zeros(size(TSpecNetLongChange(roll+1:end-1-istep,1)));
   s2=size(TFuturesReturn(roll+2+istep:end,1),1);
   dummy=zeros(s2*ss,ss);
   
  tFuturesReturn=[];
  tbasis=[];
tNetLongChange=[];
tNetLong=[];
tPressure=[];
dummy=[];
tmom=[];
   LReturn=[];
   
   tbeta=[];
         
for index=1:ss

    tNetLongChange=[THedgeNetLongChange(roll+1:end-1-istep,index)]; % change hedger to spec
    LReturn=[TFuturesReturn(roll+1:end-1-istep,index)];

    tmom=[mom(roll+1:end-1-istep,index)];
    
     tFuturesReturn=[TFuturesReturn(roll+2+istep:end,index)];
    tbasis=[Tbasis(roll+1:end-1-istep,index)];
 
    cc= find(TSpecNetLong(roll+1:end-1-istep,index)>=0);
    dd= find(TSpecNetLong(roll+1:end-1-istep,index)<0);
    Spec(cc)=1; Spec(dd)=-1;
    tPressure=[Spec.*rstd(roll+1:end-1-istep,index)];

    br=tFuturesReturn;
reg=[ones(size(br))  tNetLongChange  tbasis tPressure LReturn ];

ret=nwest(br,reg,4);
tbeta=[tbeta;ret.beta'*100];
end
  
mb=mean(tbeta,1);
tb=mean(tbeta,1)./std(tbeta)*sqrt(size(tbeta,1));
medianb=median(tbeta,1);


Tout=[mb;tb;medianb];
Tout(:,1)=[];  % delete the constant coefficient 
    