clear;   % Table 4

    load TFuturesReturn;
    load TSPReturn;
    load dates;
    load Tbasis;
    load TProdNetLongChange;
    load TSwapNetLongChange;
    load TMoneyNetLongChange;
    load TOtherNetLongChange;
    load TNonNetLongChange;
    
    load TProdNetLong;
    load TSwapNetLong;
    load TMoneyNetLong;
    load TOtherNetLong;
    load TNonNetLong;


TFama=[];
TFama2=[];
TFama3=[];
TR=[];
TR2=[];
TR3=[];
TT=[];
ss=26;
roll=52;

Spec=zeros(ss,1);

istep=0; % 0 for lag one period, 1 for two periods

for i=roll+2:size(TFuturesReturn,1)
    
    
   for bcount=1:ss
        ret=ols(TFuturesReturn(i-roll-istep:i-1-istep,bcount),[ones(roll,1) TSPReturn(i-roll-istep:i-1-istep)]);
        beta(bcount,1)=ret.beta(2);
        rstd(bcount,1)=std(ret.resid)*sqrt(52);
   end
    
    basis1=Tbasis(i-1-istep,:)';
    
    key=TMoneyNetLongChange(i-1-istep,:)';
    
    cc= find(TMoneyNetLong(i-1-istep,:)>=0);
    dd= find(TMoneyNetLong(i-1-istep,:)<0);
    
    Spec(cc)=1; Spec(dd)=-1;
        

    
    ret2=ols(TFuturesReturn(i,:)',[ones(ss,1) key   basis1 Spec.*rstd TFuturesReturn(i-1-istep,:)']);
    TFama=[TFama;ret2.beta'];

    
    TR=[TR;ret2.rsqr'];

    TT=[TT;key'];
    
end

bb=mean(TFama);

for i=1:size(bb,2)
    rr=nwest(TFama(:,i),[ones(size(TFama,1),1)],4);
    t(i)=rr.tstat;
end

out=[bb',t'];
out=[out;mean(TR) nan]




