clear;   % Table 3

load TFuturesReturn;
load TSPReturn;  % return for sp 500
load dates;
load Tbasis;
load TSpecNetLongChange; % Q for noncommercial
load THedgeNetLongChange; % Q for commercial
load TNonNetLongChange;  % Q for nonreportable
load TSpecNetLong;
load THedgeNetLong;
load TNonNetLong;


roll=52;

TFama=[];
TFama2=[];
TFama3=[];
TR=[];
TR2=[];
TR3=[];

ss=26;
Spec=zeros(ss,1);
% change -1 to -2, you can get lag-2 period results

for i=roll+1:size(TFuturesReturn,1)
    
    for bcount=1:ss
        ret=ols(TFuturesReturn(i-roll:i-1,bcount),[ones(roll,1) TSPReturn(i-roll:i-1)]);
        beta(bcount,1)=ret.beta(2);
        rstd(bcount,1)=std(ret.resid)*sqrt(52);
    end
    
    basis=Tbasis(i-1,1:ss)';

    
    key=THedgeNetLongChange(i-1,1:ss)'; % This line can be changed to other players, i.e. THedgeNetLongChange
    
    cc= find(TSpecNetLong(i-1,1:ss)>=0);
    dd= find(TSpecNetLong(i-1,1:ss)<0);
    
    Spec(cc)=1; Spec(dd)=-1;
    
   % ret2=ols(TFuturesReturn(i,:)',[ones(ss,1) key basis Spec.*rstd TFuturesReturn(i-1,:)']);
        
  ret2=ols(TFuturesReturn(i,:)',[ones(ss,1) key ]); % simple regression
   
    TFama=[TFama;ret2.beta'];

    
    TR=[TR;ret2.rsqr'];

    
end

bb=mean(TFama);

for i=1:size(bb,2)
    rr=nwest(TFama(:,i),[ones(size(TFama,1),1)],4);
    t(i)=rr.tstat;
end

out=[bb',t'];
out=[out;mean(TR) nan]

   
