clear;  % Table 11
load TFuturesReturn;
load TSPReturn;
load dates;
load Tbasis;
load TSpecNetLongChange;
load THedgeNetLongChange;
load TNonNetLongChange;
load TSpecNetLong;
load THedgeNetLong;
load TNonNetLong;
load TOI;
%%% to get the results without financial crisis, just deletet the profit
%%% during that period

HedgeSize=abs(THedgeNetLong)./TOI;

o=mean(HedgeSize,1);
HedgeSize=ones(size(THedgeNetLong,1),1)*o;  % change hedger to spec to get spec decomposition



Q=THedgeNetLongChange;


roll=52;
ss=26; 
lagQ=5;
MomLag=52;

    RsumSpecQ=zeros(size(dates,1),ss);
    PositionMom=zeros(size(dates,1),ss);
    HedgeNoise=zeros(size(dates,1),ss);
    Qmom=zeros(size(dates,1),ss);
    Qresid=zeros(size(dates,1),ss);
    s2=size(TFuturesReturn(roll+2:end,1),1);
   
  tFuturesReturn=[];
  tNetLongChange=[];
   LReturnT=[];
   LReturn=[];
   TsumSpecQ=[];

for i=roll:size(TFuturesReturn,1)
    for bcount=1:ss
        smoothHedge(i,bcount)=mean(THedgeNetLong(i-roll+1:i,bcount))/TOI(i,bcount);  % change hedger to spec to get spec decomposition     
    end
end

for index=1:ss
        tNetLongChange=[tNetLongChange; Q(2:end,index)];
     LReturn=[LReturn;TFuturesReturn(1:end-1,index)];
end
ret2=ols(tNetLongChange,[ones(size(tNetLongChange)) LReturn]);
Qmom(2:end,:)=reshape(LReturn*ret2.beta(2:end),size(Q,1)-1,ss);
Qresid(2:end,:)=reshape(ret2.resid+ret2.beta(1),size(Q,1)-1,ss);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%% above decompose momemtum

yHedgeNoise=THedgeNetLong./TOI-smoothHedge;
TyHedgeNoise=[];
for index=1:ss

    tSpecQ=[];
    for iL=0:lagQ-1
     tSpecQ=[tSpecQ,Qresid(roll+1-iL:end-iL-1,index)];
    end
    
     kLF=[];
     for iL=1:MomLag
     kLF=[kLF,TFuturesReturn(roll+1-iL:end-iL-1,index)];
    end
     LReturnT=[LReturnT;kLF];
     
     tFuturesReturn=[tFuturesReturn;TFuturesReturn(roll+2:end,index)];  
     TsumSpecQ=[TsumSpecQ;tSpecQ];
    TyHedgeNoise=[TyHedgeNoise;yHedgeNoise(roll+1:end-1,index)];
end
yret=ols(TyHedgeNoise,[ones(size(TyHedgeNoise)) LReturnT]);
PositionMom(roll+1:end-1,:)=reshape(LReturnT*yret.beta(2:end),s2,ss);
HedgeNoise(roll+1:end-1,:)=reshape(yret.resid,s2,ss)+yret.beta(1);


    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 TQmomMoneyProfit=[];
    TQresidMoney=[];
    TsmoothHedgeMoney=[];
    HedgeNoiseMoneyProfit=[];
    TSumQProfit=[];
    TPositionMom=[];
    
for i=roll:size(dates,1)-1
   
    TsmoothHedgeMoney=[TsmoothHedgeMoney;mean(smoothHedge(i,:).*TFuturesReturn(i+1,:)./HedgeSize(i,:))];
    TPositionMom=[TPositionMom;mean(PositionMom(i,:).*TFuturesReturn(i+1,:)./HedgeSize(i,:))];
    HedgeNoiseMoneyProfit=[HedgeNoiseMoneyProfit;mean(HedgeNoise(i,:).*TFuturesReturn(i+1,:)./HedgeSize(i,:))];
end


yy=TsmoothHedgeMoney+TPositionMom+HedgeNoiseMoneyProfit;

ret1=nwest(TsmoothHedgeMoney, ones(size(TsmoothHedgeMoney)),4);
ret2=nwest(TPositionMom, ones(size(TsmoothHedgeMoney)),4);
ret3=nwest(HedgeNoiseMoneyProfit, ones(size(TsmoothHedgeMoney)),4);
ret4=nwest(yy, ones(size(TsmoothHedgeMoney)),4);

out1=[ret1.beta;ret2.beta;ret3.beta;ret4.beta];
out2=[ret1.tstat;ret2.tstat;ret3.tstat;ret4.tstat];

Tout=[out1*52];




