clear;   %Table 10

load TFuturesReturn;
load TSPReturn;
load dates;
load Tbasis;
load TSpecNetLongChange;
load THedgeNetLongChange;
load TNonNetLongChange;
load TSpecNetLong;
load THedgeNetLong;
load TNonNetLong;
load TOI;


roll=52;
Thstep=[1:2];


tNetLongChange=[]; LReturn=[];

for index=1:size(TSpecNetLongChange,2)
    tNetLongChange=[tNetLongChange; TSpecNetLongChange(2:end,index)];
    LReturn=[LReturn;TFuturesReturn(1:end-1,index)];    
end

ret2=ols(tNetLongChange,[ones(size(tNetLongChange)) LReturn]);


Qmom=[]; Qresid=[];
for index=1:size(TSpecNetLongChange,2)
   
tQmom=TFuturesReturn(1:end-1,index)*ret2.beta(2);

Qmom=[Qmom,[0;tQmom]];
Qresid=[Qresid,[0;TSpecNetLongChange(2:end,index)-tQmom]];
end

Tout=[];
TR=[];
Td=[];

ss=26;
for i=roll:size(TFuturesReturn,1)
    
    for bcount=1:ss
        smoothHedge(i,bcount)=-mean(THedgeNetLong(i-roll+1:i,bcount))/TOI(i,bcount);
        
    end

end


for ihstep=1:size(Thstep,2)
    
hstep=Thstep(ihstep);

TFama=[];
out=[];


Spec=zeros(ss,1);

for i=roll:size(TFuturesReturn,1)-hstep
    
    for bcount=1:ss
        ret=ols(TFuturesReturn(i-roll+1:i,bcount),[ones(roll,1) TSPReturn(i-roll+1:i)]);
        beta(bcount,1)=ret.beta(2);
        rstd(bcount,1)=std(ret.resid)*sqrt(52);
    end
    
    basis=Tbasis(i,1:ss)';
    
    key=TSpecNetLongChange(i,:)';
    
    LReturn=TFuturesReturn(i,:)';
    
    cc= find(TSpecNetLong(i,1:ss)>=0);
    dd= find(TSpecNetLong(i,1:ss)<0);
    
    Spec(cc)=1; Spec(dd)=-1;
    
    br=TFuturesReturn(i+hstep,:)';
    
   ret2=ols(br,[Qresid(i,:)' Qmom(i,:)' smoothHedge(i,:)' LReturn basis Spec.*rstd  ones(ss,1)]);
    
    TFama=[TFama;ret2.beta'];

    
    TR=[TR;ret2.rsqr'];

    
end


bb=mean(TFama);

for i=1:size(bb,2)
    rr=nwest(TFama(:,i),[ones(size(TFama,1),1)],4);
    t(i)=rr.tstat;
end

for ibb=1:size(bb,2)-1
    out=[out;[bb(ibb)*100;t(ibb)]];
end

out=[out;mean(TR)];

    
    Tout=[Tout,out];
   
end

    
