clear;   % Table 2

load TFuturesReturn;
load dates;
load Tbasis;
load TSpecNetLongChange;
load THedgeNetLongChange;
load TNonNetLongChange;
load TSpecNetLong;
load THedgeNetLong;
load TNonNetLong;


kk=find(dates<datenum(1994,1,1));

TFuturesReturn(kk,:)=[];
dates(kk)=[];
Tbasis(kk,:)=[];
TSpecNetLongChange(kk,:)=[];
THedgeNetLongChange(kk,:)=[];
TNonNetLongChange(kk,:)=[];
TSpecNetLong(kk,:)=[];
THedgeNetLong(kk,:)=[];
TNonNetLong(kk,:)=[];

TFama=[];
TR=[];

ss=26;


for i=2:size(TFuturesReturn,1)
    
    
    
    key=THedgeNetLongChange(i,:)';  % change to spec and Non
    keyP=THedgeNetLongChange(i-1,:)'; % change to spec and Non
    
    ret2=ols(key,[ones(ss,1) TFuturesReturn(i-1,:)' keyP]);
%    ret2=ols(key,[ones(ss,1) TFuturesReturn(i,:)']);  % contemporaneous regression

    TFama=[TFama;ret2.beta'];

    
    TR=[TR;ret2.rsqr'];
    
end


bb=mean(TFama);

for i=1:size(bb,2)
    rr=nwest(TFama(:,i),[ones(size(TFama,1),1)],4);
    t(i)=rr.tstat;
end

out=[bb(2);t(2);bb(3);t(3)];
%out=[bb(2);t(2)]; if contemporaneous regression
Tout=[out;mean(TR)];
